unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  i : Integer;
  Count, Size, rc : Cardinal;
  NetHandle : THandle;
  NetResources : Array of TNetResource;
begin
// abre enumerao
  if WNetOpenEnum(RESOURCE_CONNECTED, RESOURCETYPE_ANY, 0, nil, NetHandle) <> NO_ERROR then
    Exit;
  try
// tamanho inicial de NetResources
    SetLength(NetResources,50);
    try
      while True do begin
// pega o mximo de elementos
        Count := Cardinal(-1);
        Size := Length(NetResources)*SizeOf(TNetResource);
// pega as conexes
        rc := WNetEnumResource(NetHandle, Count, @NetResources[0], Size);
// tamanho insuficiente. aumenta-o
        if rc = ERROR_MORE_DATA then begin
          SetLength(NetResources, Round(Size/Sizeof(TNetResource)+0.5));
          Continue;
        end;
        if rc <> NO_ERROR then
          Exit;
// preenche a listbox
        for i := 0 to Count - 1 do
          with NetResources[i] do
              ListBox1.Items.Add(lpRemoteName)
      end;
    finally
      NetResources := Nil;
    end;
  finally
// fecha a enumerao
    WNetCloseEnum(NetHandle);
  end;
end;

end.
